def look_at_obj(self, objecttype):
    # Step 1: Find the object
    if self.name2type(self.holding)!= self.name2type(objecttype):
        entity = self.find_object(objecttype)
        if entity is None:
            # Find receptacletypes that can contain the object
            r_types = self.find_canbe_contained(objecttype)
            if r_types is None:
                # Explore the environment
                self.explore()
                return
            else:
                # Check each receptacletype to find the object
                for r_type in r_types:
                    r_entitys = self.find_receptacles(r_type)
                    if r_entitys is None:
                        continue
                    for r_entity in r_entitys:
                        self.goto(r_entity.name)
                        if r_entity.openable and not r_entity.isopen:
                            self.open_receptacle(r_entity.name)
                            return
        else:
            # Go to the object's receptacle and take it
            self.goto(entity.in_on)
            r_entity = self.seen_entitys[entity.in_on]
            if r_entity.openable and not r_entity.isopen:
                self.open_receptacle(r_entity.name)
            self.take(entity.name, entity.in_on)
            return
    else:
        # Step 4: Go to a desklamp
        desklamp = self.find_receptacle('desklamp')
        if desklamp is None:
            # Explore the environment to find the desklamp
            self.explore()
            return
        else:
            self.goto(desklamp.name)
            # Step 5: Turn on the desklamp
            self.turn_on(desklamp.name)
            return